<template>
	<div id="app">
		<b-container>
			<comp-title />

			<b-row>
				<comp-control 
					v-bind:strSearch = "strSearch"
					v-bind:orderBy = "orderBy"
            		v-bind:orderDir = "orderDir"
					v-on:handleSearch = "handleSearch"
					v-on:handlerSort = "handlerSort"
				/>

				<comp-form 
					v-bind:isShowForm = "isShowForm"
					v-on:toggleForm = "toggleForm"
					
				/>
			</b-row>

			<todo-list-table 
				v-bind:listTask = "listTaskSort"
				v-on:handelDelete = "handelDelete"
			/>
		</b-container>
	</div>
</template>

<script>
/*
App
	CompForm
		FormAdd -> click 
			-> Run onClickAddTask() 
			-> Kích hoạt Event handleAddTask 
			-> Kích hoạt tiếp toggleForm

*/
// Lưu dũ liệu -> Không cần -> Mock Data, Fake Data
import TodoListTable from './components/TodoListTable';
import CompTitle from './components/CompTitle';
import CompControl from './components/CompControl';
import CompForm from './components/CompForm';

import listTask from './mocks/tasks';

export default {
	name: 'app',
	components: {
		CompForm,
		CompTitle,
		CompControl,
		TodoListTable
	},
	data () {
		return {
			listTask: listTask,
			isShowForm: false,
			strSearch: '',
			orderBy: 'name',
			orderDir: 'asc',
			taskSelected: null
		}
	},
	computed: {
		listTaskSearch() {
			// var newItems = [];
			// const strSearch = this.strSearch
			// console.log(this.strSearch);
			// this.listTask.forEach(function(item,index){
			// 	console.log('item' ,item.name); 

			// 	if(item.name.toLowerCase().includes(strSearch.toLowerCase()) === true){
			// 		newItems.push(item);
			// 	}
			// })
			// cách2
			const strSearch = this.strSearch;
			var newItems = this.listTask.filter( item => {
				return item.name.toLowerCase().includes(strSearch.toLowerCase()); 
			});
			return newItems;
		},
		listTaskSort(){
			var listTask = [...this.listTaskSearch];
			if (this.orderBy === 'name'){
				listTask.sort(this.compareName);
			}else if(this.orderBy === 'level'){
				listTask.sort(this.comparelevel);
			}
			
			return listTask;
		}

	},
	
	methods: {
		compareName(a,b){
			var numberSort = this.orderDir == 'asc' ? -1 : 1;
			if (a.name  < b.name)
		        return numberSort;
		      if (a.name > b.name)
		        return numberSort * (-1);
		      return 0;
		    
		},
		comparelevel(a,b){
			var numberSort = this.orderDir == 'asc' ? -1 : 1;
			if (a.level < b.level)
		        return numberSort;
		      if (a.name > b.name)
		        return numberSort * (-1);
		      return 0;
		    
		},
		toggleForm(){
			console.log('11')
			this.isShowForm = !this.isShowForm
		},
		handleSearch(data) {
            // console.log(e.target);
            this.strSearch = data;
            console.log('handleSearch capp .vue', data);
        },
        handlerSort(data) {
        	this.orderBy = data.orderBy;
        	this.orderDir = data.orderDir;
        },
        //xóa bằng filter so sánh id hiện tại vs id click cách1
       // handelDelete(taskDelete){
       // 	console.log(taskDelete.id)
       // 		this.listTask = this.listTask.filter(item => item.id !== taskDelete.id);
       // }
       

       	cách 2 : xóa bằng slipe
       handelDelete(taskDelete){
       	console.log(taskDelete.id)
       		this.listTask = this.listTask.filter(item => item.id !== taskDelete.id);
       }
	}
}
</script>

<style>
body {
    padding: 100px 0;
}
.table>tbody>tr>td, .table>tbody>tr>th, .table>tfoot>tr>td, .table>tfoot>tr>th, .table>thead>tr>td, .table>thead>tr>th {
    vertical-align: middle;
}

.container > .row {
    margin-top: 20px;
    margin-bottom: 30px;
}

span.badge-medium {
	padding: 11px 10px;
    margin: 0px 8px;
    font-size: 16px;
    display: inline-block;
    vertical-align: top;
}

@media (max-width: 992px) {
    .add-task {
        margin-top: 50px;
    }
}

</style>
